//package Zadanie;

//import javax.swing.*;
//import javax.swing.event.*;
 
//import java.util.*;
import java.awt.*;
//import java.awt.image.*;
import java.awt.geom.*;
//import java.awt.event.*;

//--------------------------------------------------------------------------------//
//  					Trieda jedneho jedinca                                    //
//--------------------------------------------------------------------------------//

public class Floy extends Thread{													//definicia jedneho jedinca ako vlakna
	private double x;				//poloha x
	private double y;				//poloha y
	private double x_tail;			//poloha chvosta
	private double y_tail;
	private int speed;				//rychlost
	private Color color;			//farba
	private int type;				//typ -> 0 - domaci, 1 - votrelec
	public float energy;				//energia jedinca

	private int votrelec_x;			//suradnice votrelca
	private int votrelec_y;
	private int prekazka_x;			//suradnice centra prekazok
	private int prekazka_y;
	private int neighbous_x;		//suradnice centra rovnakych floyov
	private int neighbous_y;
	private float vx;				//posun po osiach x, y	
	private float vy;
	private double final_x;			//konecne suradnice miesta uniku (pohybu)
	private double final_y;
	private double home;
	
	static float maxspeed;			//maximalna rychlost
	static float bouncespeed;		//pociatocna rychlost
	static float acc;				//zrychlenie
	static float v0;				//pociatocna rychlost
	private int rev;
	private Floy votrelec;
	static FloyCanvas Floys;
	private double time;
	
    int []home_x={400,50};
    int []home_y={300,50};
    int model_hranic;
    int akcia;
    
    
	int maxEnergy;
	int healingRate;
	int zmenaEnergy; 
	int hniezdoDst;
	float poklesEnergie;
 
    boolean cas;
    boolean zachrana;
    boolean hniezdo;
    boolean mnozenie;
    boolean drawHranice;
    
  	Barrier nearest_barrier;
	
  	public void setHome(int dx, int dy, int vx, int vy)
  	{ 
  		home_x[0]=dx;
  		home_x[1]=vx;
  		home_y[0]=dy;
  		home_y[1]=vy;
	}
	public int getMaxEnergy() { return  maxEnergy; };
	public void setMaxEnergy(int c) { maxEnergy=c;};
	public void setHealingRate(int c) { healingRate=c;};
	public void setZmenaEnergie(int c) { zmenaEnergy=c;};
	public void setHniezdoDst(int c) { hniezdoDst=c;}
	public void setPoklesEnergie(float c) { poklesEnergie=c;}
	
    public int getType(){return type;}
    public int getSpeed(){return speed;}
  	public void setTime(double t){ time=t;}
  	public void setDrawHranice(boolean x){ drawHranice=x;}
  	public void setMnozenie(boolean x){ mnozenie=x;}
	public void setCas(boolean c) { cas=c;}
	public void setHniezdo(boolean c) { hniezdo=c;}
	public void setZachrana(boolean c) { zachrana=c;}
	public void setHranice(int c) { model_hranic=c;}
	
  	
	public Floy (float x, float y, int energy, int speed, Color color, int type)				//konstruktor
	  {
	  	this.x = x;
	  	this.y = y;
	  	this.energy = energy;										
	  	this.speed = speed;
	  	this.color = color;
	  	this.type = type;
	  	
	  	x_tail = x;
	  	y_tail = y;
	  	
	  	if (type == 0)															//pre floya
	  	  {
	     	vx = (float)Math.random()*v0-v0/2;									//nastavenie pociatocneho smeru 
	  	    vy = (float)Math.random()*v0-v0/2;
	  	  }
	  	else																	//pre votrelca
	  	  {
	  	   vy = (float)Math.random()*v0;
           vx = (float)Math.random()*v0;									//nastavenie pociatocneho smeru 
	  	  }
	  	time=0;

	    cas=true;
	    zachrana=true;
	    hniezdo=true;
	    model_hranic=0;
	    akcia=0;
	    drawHranice=false;
	    mnozenie=true;
	    this.zmenaEnergy=2;
	    this.maxEnergy=200;
	    this.healingRate=2;
//	    this.maxspeed=3;
	    this.hniezdoDst=50;
	    this.poklesEnergie=0.0f;
	  }
	  
	public int getAkcia()
	{
			int x=akcia;
			akcia=0;
			return x;
	}

	public void run()																//metoda spustenia vlakna
	  {
     	int i,j,d, k;
      		  	rev=1;
	  	while (true)																//nekonecna slucka
	  	  {
	  	  	try
	  	  	  {
	  	  	  	sleep(26-(int)((Math.log((double)speed/2)/Math.log(10))*20));		//zastavi beh vlakna na urceny cas 
	  	  	  	
	  	  	  }															
	  	  	catch (InterruptedException e)
	  	  	  {
	  	  	  	return;
	  	  	  }
//----------------------------------------------------------------------------------//
//					Vypocet pohybu jedinca											//
//----------------------------------------------------------------------------------//	  	  	

 		x_tail = x;
 		y_tail = y;
 		final_x=final_y=0;
      	k=0;
      	votrelec_x=votrelec_y = 1000;
      	prekazka_x=prekazka_y=neighbous_x=neighbous_y = 0;      	            			   
      	zakladnyModel();                                     
        modelPohybu();      	
 	    modelProstredia();
 	    modelBarier();
		normovanieRychlosti();
		kontrolaEnergie();
	  }
	}
	
	void modelBarier(){
		if (Floys.barriers.size()!=0)						//ak su umiestnene prekazky najde najblizsiu z nich
		  { 
		   Barrier bariera;					 
		   nearest_barrier = (Barrier)Floys.barriers.get(0);
		    
		   for (int i=1; i<Floys.barriers.size(); i++)
           {		   
            bariera = (Barrier)Floys.barriers.get(i);
			  if (Distance(bariera.getX(),bariera.getY())<Distance(nearest_barrier.getX(),nearest_barrier.getY()))
			    nearest_barrier = bariera;
		     }		    		  
		   kolizie();
	  }
	}
	
	void modelPohybu(){		
		if (prekazka_x !=0 )							
			{ modelObchadzaniaPrekazok();}
		else if((time<150 || time>850) && cas==true)		
			{ modelCasu();}
		else if(energy<maxEnergy/10 && zachrana==true)
			{ modelZachrany(); }
		else if(this.Distance(home_x[type],home_y[type])<hniezdoDst && hniezdo==true) 
			{ energy+=healingRate; }
		else if(votrelec_x != 1000)							
			{ modelSpravaniaKvotrelcom(); }
		else if(neighbous_x != 0)							
			{ modelSpravaniaKvlastnym(); }	  	  

		this.energy-=poklesEnergie*rev;
		//urcenie smeru pohybu
		if(final_x != 0)							
		{
		   if (x < final_x) vx += acc*rev;
		   else vx -= acc*rev;
		   if (y < final_y) vy += acc*rev;
		   else vy -= acc*rev;	          	
	    }
	}
	
	void modelSpravaniaKvotrelcom()
	{        
		// vzdialenost od hniezda
		home = this.Distance(home_x[this.type],home_y[this.type]);
		// vzdialenost medzi hniezdami
        double totdst = Math.sqrt(Math.pow(home_x[1]-home_x[0],2)+Math.pow(home_y[1]-home_y[0],2));
        // pomer medzi tymi vzdialenostami
        home /= totdst;
	
		final_x = votrelec_x;
		final_y = votrelec_y;
		int maxSpeedVot=20, maxSpeedObet=-18;			
		rev=5;
	 switch(model_hranic){
	 // modri su predatori, predator je rychlejsi ako obet 
	 	case 3:{
	 		if(this.type==1){
				if(Distance(votrelec_x, votrelec_y)<10)	energy+=zmenaEnergy; // nazeriem sa z neho :)
				rev = maxSpeedVot;	 			
	 		}
		 	if(this.type==0){
				if(Distance(votrelec_x, votrelec_y)<10)	energy-=zmenaEnergy; // nazeriem sa z neho :)
	 			rev = maxSpeedObet;	 			
	 		}
	 	} break;
	 // cerveni su predatori
	 	case 4:{
	 		if(this.type==0){
				if(Distance(votrelec_x, votrelec_y)<10)	energy+=zmenaEnergy; // nazeriem sa z neho :)
	 			rev = maxSpeedVot;	 			
	 		}
		 	if(this.type==1){
				if(Distance(votrelec_x, votrelec_y)<10)	energy-=zmenaEnergy; // nazeriem sa z neho :)
	 			rev = maxSpeedObet;	 			
	 		}
	 	} break;
	 	case 0:
	 	{
	 		// ak je moja vzdialenost k domovu mensia ako jeho 
	 		if(this.home*totdst < votrelec.home*totdst)
			{	
				if(Distance(votrelec_x, votrelec_y)<10)	energy+=zmenaEnergy; // nazeriem sa z neho :)
				rev = maxSpeedVot;
			}
			else
			{								//ak je pri mne blizko a kusol ma, klesne mi energia
				if(Distance(votrelec_x, votrelec_y)<10)	energy-=zmenaEnergy;
				rev = maxSpeedObet;  
			}
	 	} break;
	 	case 5:
	 	{
			// ak som blizko domu, som predator a nazeriem sa z neho :)
			if(this.home <= 0.5)
			{	
				if(Distance(votrelec_x, votrelec_y)<10)	energy+=zmenaEnergy;
				rev = maxSpeedVot;
				final_x = votrelec_x;
				final_y = votrelec_y;
			}else
			if(this.home > 0.5)
			{								
				if(Distance(votrelec_x, votrelec_y)<10)	energy-=2;
				rev = -maxSpeedObet;  
				final_x = home_x[this.type];
				final_y = home_y[this.type];
			}		 
	 	} break; 	
	 	case 1:
	 	{
			// ak som blizko domu, som predator a nazeriem sa z neho :)
			if(this.home < 0.4)
			{	
				if(Distance(votrelec_x, votrelec_y)<10)	energy+=zmenaEnergy;
				rev = maxSpeedVot;
				final_x = votrelec_x;
				final_y = votrelec_y;
			}else
			if(this.home >= 0.4 && this.home <= 0.6)
			{				 
				if(Distance(votrelec_x, votrelec_y)<10)
				{
					if(Math.random()%2 == 1) 
					{ 
						final_x = votrelec_x;
						final_y = votrelec_y;
						rev=maxSpeedVot;
						energy+=zmenaEnergy; 
					}
					else 
					{ 
						final_x = home_x[this.type];
						final_y = home_y[this.type];
						rev=maxSpeedObet;
						energy-=zmenaEnergy; 
					}
				}
				rev = (int)(Math.random()*40-20);
			}else
			//ak som daleko z domu a kusol ma, klesne mi energia
			if(this.home > 0.6)
			{								
				if(Distance(votrelec_x, votrelec_y)<10)	energy-=2;
				rev = -maxSpeedObet;  
				final_x = home_x[this.type];
				final_y = home_y[this.type];
			}		 
	 	} break;
	 	case 2:
	 	{
			if(this.home < 0.4)
			{	
				if(Distance(votrelec_x, votrelec_y)<10)	energy+=zmenaEnergy; // nazeriem sa z neho :)
				rev = maxSpeedVot;
				final_x = votrelec_x;
				final_y = votrelec_y;
			}else
			if(this.home >= 0.4 && this.home <= 0.6)
			{				 
				if(Distance(votrelec_x, votrelec_y)<10)
				{
					final_x = votrelec_x;
					final_y = votrelec_y;
					//rev=maxSpeedVot/2;
					energy-=zmenaEnergy/2; 			  	
				}
				// v strede prebieha boj, rychlost sa generuje nahodne 
				rev = (int)(Math.random()%(2*maxSpeedVot)-maxSpeedVot);
			}else
			if(this.home > 0.6)
			{								//ak je pri mne blizko a kusol ma, klesne mi energia
				if(Distance(votrelec_x, votrelec_y)<10)	energy-=zmenaEnergy;
				rev = -maxSpeedObet; // bolo +  
				final_x = home_x[this.type];
				final_y = home_y[this.type];
			}
	 	} break;
	 	default:
	 	{
		 	if(this.home < votrelec.home)
			{	
				if(Distance(votrelec_x, votrelec_y)<10)	energy+=zmenaEnergy; // nazeriem sa z neho :)
				rev = maxSpeedVot;
			}
			else
			{								//ak je pri mne blizko a kusol ma, klesne mi energia
				if(Distance(votrelec_x, votrelec_y)<10)	energy-=zmenaEnergy;
				rev = maxSpeedObet;  
			}
	 	} break; 	 			 	
	 }
	 
	}


	
	void kontrolaEnergie(){
		// obmedzenie na maximalnu energiu
 		if (energy > maxEnergy)
 		{
 			// ak je zapnute mnozenie, rozmnozi sa
// 			if(mnozenie==true) Floys.PridajNovehoFloya(Floys.objects.indexOf(this));
 			energy=maxEnergy; 			
 		} 	
 		//ak je energia nulova, musi zomriet
 		if (energy < 1)															
		  { 		   
//		   Floys.OdstranMrtvehoFloya(Floys.objects.indexOf(this));
		   energy=0;
		  }	
	}
	void normovanieRychlosti(){
		// jednoduche kriterium - pohym po diagonale (x a y rychlosti rovnake)
		//if (vx > maxspeed) vx = maxspeed;										//aby rychlost nepresiahla maximalnu rychlost
		//if (vx < -maxspeed) vx = -maxspeed;
		//if (vy > maxspeed) vy = maxspeed;
		//if (vy < -maxspeed) vy = -maxspeed;

		// kriterium, kde sa rozdeli maximalna rychlost na x a y zlozku		
		double dd = Math.sqrt(Math.pow(vx,2)+Math.pow(vy,2));
        double kk=1;
        if(dd > maxspeed){ kk = maxspeed / dd; }
       	vx*=kk;
       	vy*=kk;               
		x += vx;																//vypocet suradnic do dalsieho kroku
		y += vy;	
	}
	void modelObchadzaniaPrekazok()
	{
		final_x = prekazka_x;
		final_y = prekazka_y;
		rev = -2;
	}
	
	void modelCasu()
	{
		final_x = home_x[type];
		final_y = home_y[type];
		rev = 1;
	}
	void modelZachrany(){
			final_x = home_x[type];
			final_y = home_y[type];
			rev = 1;		
	}
	void modelSpravaniaKvlastnym(){
		final_x = neighbous_x;
			final_y = neighbous_y;
			rev = 1;
		}
	
	void kolizie(){
		   if (Distance(nearest_barrier.getX(),nearest_barrier.getY())<(Floys.GetCrashDistance()+20+nearest_barrier.radius))  
		     {
		      double angle;					//uhol pohybu jedinca oproti x-ovej osi
		      double barrier_angle;			//uhol bariery k jedincovi a osi x
		      double alfa;					//uhol k dotycnici
		      
		      angle = GetAngle(vx,vy);
		      barrier_angle = GetAngle((float)(nearest_barrier.getX()-x),(float)(nearest_barrier.getY()-y));	//dufam ze to je dobre
			  alfa = Math.asin((double)(nearest_barrier.radius+5)/Distance(nearest_barrier.getX(),nearest_barrier.getY()));
		    		    
		      if (((barrier_angle+alfa)>angle)&&((barrier_angle-alfa)<angle))	//ak prekaska zavadza v pohybe
		        {
  	    	 double prepona;

		         prepona = Math.sqrt((double)(vx*vx)+(vy*vy));  						// povodna rychlost 
		         angle -=alfa;															//novy uhol otoceny o alfa

		    	 vx = (float)(Math.cos(angle)*prepona);									//nove suradnice posunute o uhol alfa
		    	 vy = -1f*(float)(Math.sin(angle)*prepona);
	     	    }
	     	    
		      if (Distance(nearest_barrier.getX(),nearest_barrier.getY())<=nearest_barrier.radius+2)		//ak je uz velmi blizko
		        {
		         if ((Math.abs(angle)>Math.PI/4)&&(Math.abs(angle)<Math.toRadians(135)))
		           {
		     	    vx=1;
		     	    vy=0;	
		     	   }
		     	 else
		     	   {
		     	   	vy=1;
		     	   	vx=0;
		     	   } 
		        }  		
		     }
	}

	synchronized void zakladnyModel(){
     	int i,j,d, pocet_prekazok=0, pocet_susedov=0, pocet_barier=0, k;
     	rev=1;
      	Floy pom;
	       for (i=0; i<Floys.objects.size(); i++)							//hlada vsetkych susedov v dohladnej vzdialenosti
	       {
	          	pom = (Floy)Floys.objects.get(i);
	          	if(pom==null) { System.out.println("BORDEL s okolim!"); continue;}
	          	d = Distance(pom.x, pom.y);
	            if (d != 0)															//okrem seba sameho
	            {
	     	   	   if (d < Floys.GetNeighborDistance())								//ak je jedinec na dohlad
	         	   {
	         	     if (pom.type != this.type)
	         	     {
	         	      	if (Distance(pom.x,pom.y)<Distance(votrelec_x,votrelec_y)){		//aby nahanali najblizsieho votrelca
	         	      		votrelec_x = (int)pom.x;			
	         	     		votrelec_y = (int)pom.y;
	         	     		votrelec=pom;
	         	      	}
	         	     }
	         	     else if (d < Floys.GetCrashDistance())								//ak je prilis blizko
			     	 {
	 	     	        prekazka_x += pom.x;
			     	    prekazka_y += pom.y; 
			     	    pocet_prekazok++;	
			     	 }
			     	 else															//ak je na dohlad rovnaky jedinec
			     	 {
			     	    neighbous_x += pom.x;
			     	    neighbous_y += pom.y;
			     	    pocet_susedov++;
			     	 }
	         	   }
	 			}
			}
		 if (pocet_prekazok !=0)
		   {  
		    prekazka_x = prekazka_x/pocet_prekazok;
		    prekazka_y = prekazka_y/pocet_prekazok;
	       }
		 if (pocet_susedov !=0)
		   {  
		    neighbous_x = neighbous_x/pocet_susedov;
		    neighbous_y = neighbous_y/pocet_susedov;
	       }
	}
	
	void modelProstredia(){
      	if ( Floys.model_prostredia == 2)					//ak je nastaveny ohranoceny model
    	  {  	  	
			if (x < 5) vx = bouncespeed;						//osetrenie kolizie s okrajmi plochy
			if (x > 450) vx = -bouncespeed;
			if (y < 5) vy = bouncespeed;
			if (y > 360) vy = -bouncespeed;
	      } 
		else												//ak je nastaveny toroid
		  { 
		    if (x < 5) x = 455 + x; 
		    else x = x % 455;
	        if (y < 5) y = 365 + y; 
	        else y = y % 365;
	        x_tail = x;
	        y_tail = y;
		  }

	}
	
	public double GetX()															//motody na vratenie hodnot premennych
	  {
	  	return x;
	  }  
	  
	public double GetY()
	  {
	  	return y;
	  }  
	
	public int GetType()
	  {
	  	return type;
	  }
	  
	public void setSpeed(int speed)
	  {
	  	this.speed = speed;
	  }  
	  
	public int Distance(double posX, double posY)								//metoda na zistenie vzdialenosti od ineho objektu
	  {
	  	int d,d1,d2;
	  	
	  	d1 = (int)(this.x-posX);
	  	d2 = (int)(this.y-posY);
	  	d = (int)Math.sqrt((d1*d1)+(d2*d2));
	  	return (d);
	  }

	public void selfPaint(Graphics2D area) 											//metoda na vykreslenie jedneho jedinca
	  {

        Color c=new Color(0,0,0);
        if(type==1){
        	if(energy <= maxEnergy/4)
            	c=new Color(100, 100, 255 );
        	else
           	if(energy <= maxEnergy/2)
               	c=new Color(10, 10, 200 );
        	else
        	if(energy > maxEnergy/2)
            	c=new Color(0, 0,  120 );
        }
        if(type==0){
        	if(energy <= maxEnergy/4)
            	c=new Color(255, 100, 100 );
        	else
           	if(energy <= maxEnergy/2)
               	c=new Color(200, 10, 10  );
        	else
        	if(energy > maxEnergy/2)
            	c=new Color(120, 0, 0);
        }
		area.setColor(c);														//nastavi farbu jedinca
        area.fill(new Ellipse2D.Double((int)x-2, (int)y-2, 4 , 4));					//nakresli kruzok
 		area.draw(new Line2D.Double((int)x, (int)y, (int)x_tail+(x_tail-x)*2, (int)(y_tail)+(y_tail-y)*2) );

 		//nakresli domov 		
		if(type==0)area.setColor(new Color(200,0,0));
		else if(type==1)area.setColor(new Color(0,0,200));
		// nakresli kruzok
        area.fill(new Ellipse2D.Double((int)home_x[this.type]-4, (int)home_y[this.type]-4, 8 , 8));					
		// vzdialenost medzi hniezdami
        double totdst = Math.sqrt(Math.pow(home_x[1]-home_x[0],2)+Math.pow(home_y[1]-home_y[0],2));
        // kresli hranice
        if(drawHranice==true){
    		if(type==0)area.setColor(new Color(250,120,120));
    		else if(type==1)area.setColor(new Color(120,120,250));
        	totdst*=0.4;        
        	area.draw(new Ellipse2D.Double(home_x[this.type]-totdst,home_y[this.type]-totdst,totdst*2,totdst*2));
/*        	for(double u=0;u<6.28;u+=6.28/360){
        		area.draw(new Line2D.Double(
        				home_x[type]+totdst*Math.cos(u),
        				home_y[type]+totdst*Math.sin(u),
						home_x[type]+totdst*Math.cos(u),
						home_y[type]+totdst*Math.sin(u)));
        	}
*/
    		if(type==0)area.setColor(new Color(255,200,200));
    		else if(type==1)area.setColor(new Color(200,200,255));
        	totdst*=1.5;
        	area.draw(new Ellipse2D.Double(home_x[this.type]-totdst,home_y[this.type]-totdst,totdst*2,totdst*2));
/*        	for(double u=0;u<6.28;u+=6.28/360){
        		area.draw(new Line2D.Double(
        				home_x[type]+totdst*Math.cos(u),
        				home_y[type]+totdst*Math.sin(u),
						home_x[type]+totdst*Math.cos(u),
						home_y[type]+totdst*Math.sin(u)));
        	}
*/
        }
      }
 
 
 	public double GetAngle(float vx, float vy)							//metoda na zistenie uhla k x-ovej suradnici
	  {
	  	double angle;
	  	
	  	if (vy == 0)
	  	  return (0);
	  	else if (vx == 0)
	  	  return (90);  
	    else
	      angle = Math.atan((double)Math.abs(vy)/Math.abs(vx));			//vypocitam uhol od 0 do 90 stupnov
	  
	    if (vx > 0)
	      {
	  	   if (vy >0)
	  	     {	  
	  	      angle *= -1;
	  	     } 	  
	  	  }   
	  	else 		//ak vx < 0
	  	  {
		   if (vy > 0)
		     {
		      angle = -1*(Math.PI - angle);	
		     }
		   else  	//ak vy <0
		     {
		      angle = Math.PI - angle; 
		     }  
		  }
		return (angle);
	  }

   public float SetVX(float vy, double alfa)
     {
      float vx;
      
      vx = (float)Math.tan(alfa)*vy; 
      
      return (vx);	
     }
     
   public float SetVY(float vx, double alfa)
     {
      float vy;
      
      vy = (float)(vx/Math.tan(alfa));
      
      return (vy);	
     }  
     
}



